import { Parser } from 'lezer';
import { LezerLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = Parser.deserialize({
  version: 13,
  states: "!pQYQPOOOhQPO'#CiO!PQPO'#CfOOQO'#Cm'#CmQYQPOOOYQPO,58|OYQPO,58|OYQPO,59QOOQO-E6g-E6gOOQO1G.h1G.hO!UQPO1G.hO!pQPO1G.lOOQO7+$W7+$W",
  stateData: "!{~O`OSPOS~ORROSROTROZQO~OVTOWUOR]XS]XT]XZ]X^]X~O[VO~OVTORUiSUiTUiWUiZUi^UiXUi~OVTOWUOX[O~O",
  goto: "}bPPPPPPcPPPcPPjPPPpZROSTUVQSORWSSPOSQXTQYURZV",
  nodeNames: "⚠ LineComment Program Identifier String Boolean BinaryExpression And Or ) Function Keyword (",
  maxTerm: 17,
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "'h~RaXY!WYZ!W]^!Wpq!Wrs!ist#Wxy#fyz#k}!O#p!Q![#p!]!^$^!c!d$i!d!q#p!q!r&`!r!}#p#R#S#p#T#o#p~!]S`~XY!WYZ!W]^!Wpq!W~!lTOr!irs!{s#O!i#O#P#Q#P~!i~#QOS~~#TPO~!i~#ZQ#Y#Z#a#h#i#a~#fOT~~#kO[~~#pOX~~#uUR~}!O#p!Q![#p![!]$X!c!}#p#R#S#p#T#o#p~$^OZ~~$cQP~OY$^Z~$^~$nWR~}!O#p!Q![#p![!]$X!c!p#p!p!q%W!q!}#p#R#S#p#T#o#p~%]WR~}!O#p!Q![#p![!]$X!c!f#p!f!g%u!g!}#p#R#S#p#T#o#p~%|UV~R~}!O#p!Q![#p![!]$X!c!}#p#R#S#p#T#o#p~&eWR~}!O#p!Q![#p![!]$X!c!t#p!t!u&}!u!}#p#R#S#p#T#o#p~'UUR~W~}!O#p!Q![#p![!]$X!c!}#p#R#S#p#T#o#p",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const papershiveLanguage = LezerLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false })
            }),
            foldNodeProp.add({
                Application: foldInside
            }),
            styleTags({
                Identifier: tags.string,
                Boolean: tags.bool,
                String: tags.string,
                LineComment: tags.lineComment,
                "( )": tags.paren,
                And: tags.keyword,
                Or: tags.keyword,
                Keyword: tags.keyword
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
function papershive() {
    return new LanguageSupport(papershiveLanguage);
}

export { papershive, papershiveLanguage };
